﻿<?php	
	/*
		Dieses Script erwartet Wetterdaten wie sie von der Wetterstation "HP1000SE PRO" (z.B. von froggit) gesendet werden können.
		Dazu muss in der Wetterstation die Einstellung Setup->Weather Server->Customized aktiviert werden. Protokolltyp "Same As Ecowitt".
		Hostname: Adresse eines eigenen Webservers. Path: ein selbst erzeugtes Verzeichnis auf dem Server. 
		In dem Verzeichnis wird nur diese Datei benötigt.

		Für Protokolldatei und CSV-Datei sollten (wenn gewünscht) die entsprechenden Unterverzeichnisse erzeugt werden. Andernfalls die
		Einträge "$csvfile" und/oder "$logfile" anpassen oder leer (="") machen.
		
		Zum Eintragen in eine MySQL-Datenbank müssen die Einstellungen $srv, $db, $usr, $pw, $tbl (siehe unten) korrekt ausgefüllt werden.
		
		Zum Testen der Funktion kann die Adresse 
		http://<Hostname>/<Path>/index.php
		im Browser aufgerufen werden. 
		Dann wird je nach gültigen Einträgen 
			- eine Log-Datei
			- eine CSV-Datei
			- eine Datenbanktabelle "wetter" mit einem Datensatz 
		erzeugt und ein "Dummy"-Datensatz im Browser angezeigt.
		
	*/

	//wenn einer der folgenden Werte leer ist (""), wird nicht in die Datenbank geschrieben
	$srv = "localhost"; //Servername/-adresse
	$db = "wetter";     //Datenbankname
	$usr = "wetter";		//Benutzer-/Anmeldename
	$pw = "4Wttr+Lkal"; //Passwort
	$tbl = "wetter";    //Name der Tabelle für die Wetterdaten

	//CSV-Datei wird geschrieben, wenn $logfile != "" (leer))
	$csvfile = 'csv/'.date('Y-m-d').'.csv';
			
	//Protokollierung wird geschrieben, wenn $logfile != "" (leer)
	$logfile = 'log/'.date('Y-m-d').'.log';

	
	
	if ($logfile != "")
	{
		$l = fopen($logfile, 'a');
		fwrite($l, $_SERVER['REMOTE_ADDR'].':'.print_r($_POST, true));
	}
	else	
		$l = false;
	
	if ($csvfile != "")
	{
		if (!file_exists($csvfile)) {
			//wenn neue Log-Datei, schreib' Spaltenüberschriften.
			$f = fopen($csvfile, 'a');
			fwrite($f, '"Timestamp","UTC","Temp Innen","Feuchte Innen","Temp Außen","Feuchte Außen","Luftdruck",'.
							'"Wind Richtung","V Wind","V Wind Bö","Solarleistung","UV-Intensität","Regenrate",'.
							'"Regen aktuell","Regen/Tag","Regen/Woche","Regen/Monat","Regen/Jahr",'
							.'"Batterie 1","Batterie 2","Sender-IP"'.PHP_EOL);
		}
		else {
			$f = fopen($csvfile, 'a');
		}
	}
	else
		$l = false;

	$ti = -999;
	$ta = -999;
	$fi = -999;
	$fa = -999;
	$druck = -999;
	$wr = -999;
	$ws = -999;
	$wsg = -999;
	$sr = -999;
	$uv = -999;
	$rnrate = -999;
	$rnevt = -999;
	$rndy = -999;
	$rnwk = -999;
	$rnmth = -999;
	$rnyr = -999;
	$bat1 = -999;
	$bat2 = -999;
	$sip= '';
	
	//Alle Werte werden in "imperial" (amerikanischen) Einheiten übertragen.
	//Übertrage alle POST-Parameter in variable, ggf. mit Konvertierungen.
	$p = $_POST;
	$d = "'".($p['dateutc'] ?: @date('Y-m-d H:i:s'))."'";
	$ti = round(($p['tempinf'] - 32)*5/9, 1);
	$fi = $p['humidityin'] * 1;
	$ta = round(($p['tempf'] - 32)*5/9, 1);
	$fa = $p['humidity'] * 1;
	$druck = round($p['baromabsin']/0.029529980164712, 1);
	$wr = $p['winddir'] * 1;
	$ws = round(($p['windspeedmph'])  * 0.44704, 1);
	$wsg = round(($p['windgustmph']) * 0.44704, 1);
	$sr = $p['solarradiation'] * 1;
	$uv = $p['uv'] * 1;
	$rnrate = $p['rainratein'] * 25.4;
	$rnevt = $p['eventrainin'] * 25.4;
	$rndy = round($p['dailyrainin'] * 25.4, 1);
	$rnwk = round($p['weeklyrainin'] * 25.4, 1);
	$rnmth = round($p['monthlyrainin'] * 25.4, 1);
	$rnyr = round($p['yearlyrainin'] * 25.4, 1);
	
	$bat1 = $p['wh68batt'] * 1;
	$bat2 = $p['wh40batt'] * 1;
	$sip = "'{$_SERVER["REMOTE_ADDR"]}'";

	$str = @date("'d.m.Y H:i:s'")
					.",$d,$ti,$fi,$ta,$fa,$druck,$wr,$ws,$wsg,$sr,$uv,$rnrate,$rnevt,$rndy,$rnwk,$rnmth,$rnyr,$bat1,$bat2,$sip"
					.PHP_EOL;
	if ($f)
	{
		$fstr = str_replace("'", '"', $str);
		fwrite($f, $fstr);
	}

	echo $str;

/*
echo "Timestamp $d".PHP_EOL."Druck $druck".PHP_EOL."Temp innen $ti".PHP_EOL.
			"Temp außen $ta".PHP_EOL."Feuchte innen $fi".PHP_EOL."Feuchte außen $fa".PHP_EOL.
			"Windrichtung $wr".PHP_EOL."Windgeschwindigkeit $ws".PHP_EOL."in Böen $wsg".PHP_EOL.
			"Sonneneinstrahlung $sr".PHP_EOL."UV-Intensität $uv".PHP_EOL.
			"Regenrate $rnrate".PHP_EOL."Regen Ereignis $rnevt".PHP_EOL."Regen/Tag $rndy".PHP_EOL.
			"Regen/Woche $rnwk".PHP_EOL."Regen$Monat $rnmth".PHP_EOL."Regen/Jahr $rnyr".PHP_EOL.
			"Batterie 1 $bat1".PHP_EOL."Batterie 2 $bat2".PHP_EOL."Sender-IP $sip".PHP_EOL.PHP_EOL;
*/	

	$chktable = <<<EOT
		CREATE TABLE if not exists $tbl (
			ts TIMESTAMP DEFAULT current_timestamp(),
			dateutc DATETIME DEFAULT NULL,
			luftdruck INT(11) DEFAULT NULL,
			temperatur1 DECIMAL(10, 2) DEFAULT NULL,
			temperatur2 DECIMAL(10, 2) DEFAULT NULL,
			feuchte1 INT(11) DEFAULT NULL,
			feuchte2 INT(11) DEFAULT NULL,
			v_wind_boe DECIMAL(10, 2) DEFAULT NULL,
			windrichtung INT(11) DEFAULT NULL,
			v_wind DECIMAL(10, 2) DEFAULT NULL,
			sonne DECIMAL(10, 2) DEFAULT NULL,
			uv DECIMAL(10, 2) DEFAULT NULL,
			regen_rate DECIMAL(10, 6) DEFAULT NULL,
			regen_ereignis DECIMAL(10, 6) DEFAULT NULL,
			regen_tag DECIMAL(10, 6) UNSIGNED DEFAULT NULL,
			regen_woche DECIMAL(10, 0) DEFAULT NULL,
			regen_monat DECIMAL(10, 3) DEFAULT NULL,
			regen_jahr DECIMAL(10, 3) DEFAULT NULL,
			wh68batt DECIMAL(10, 3) DEFAULT NULL,
			wh40batt DECIMAL(10, 3) DEFAULT NULL,
			sender_ip VARCHAR(20) DEFAULT NULL,
			PRIMARY KEY (ts)
		)
		CHARACTER SET utf8
		COLLATE utf8_general_ci;
EOT;
		
	$qry = <<<EOT
		insert into $tbl (
				dateutc, luftdruck, temperatur1, temperatur2, feuchte1, feuchte2
				, windrichtung, v_wind, v_wind_boe
				, sonne, uv, regen_rate, regen_ereignis
				, regen_tag, regen_woche, regen_monat, regen_jahr
				, wh68batt, wh40batt, sender_ip)
			values (
				$d, $druck, $ti, $ta, $fi, $fa
				, $wr, $ws, $wsg
				, $sr, $uv, $rnrate, $rnevt
				, $rndy, $rnwk, $rnmth, $rnyr
				, $bat1, $bat2, $sip
				);
EOT;
				
//	echo($qry.PHP_EOL);
	if ($srv!="" && $usr!="" && $pw!="" && $db !="")
  {
		$cn = new mysqli($srv, $usr, $pw, $db);
		if (!$conn->connect_error) {
			$rs = $cn->query($chktable);
			if ($rs)
				$rs = $cn->query($qry);
			if (!$rs)
			{
				if ($l)
					fwrite($l, "Query Failed".PHP_EOL.$qry);
				echo PHP_EOL."Query Failed".PHP_EOL.$qry;
			}
		}	
	}
	if ($l)
		fclose($l);
	
	if ($f)
		fclose($f);


/* https://www.wetterstationsforum.info/viewtopic.php?t=1255 */

/* 
Hallo zusammen,
vor ca. 1 Monat habe ich mir eine froggit HP1000SE pro single sensor edition zugelegt.
Vor allem fand ich interessant, dass man die Daten auch an einen eigen Server senden kann.
Bei meiner Suche vorher habe ich bemerkt, dass auch andere die Daten gerne in ihrem eigenen Format speichern möchten.

Ich habe Zuhause eine Synology Diskstation, die auch einen Webserver bereitstellt. An diesen sende ich jetzt die Daten.
Das PHP-Script, mit dem ich die Daten auswerte und in meine Datenbank schreibe habe ich für alle intessierten an diesen Beitrag angehängt.
Das Script kann die Daten auf Wunsch zusätzlich oder statt dessen in eine .csv-Datei und/oder eine Protokolldatei schreiben.

Die Erklärung, wie das einzustellen ist, habe ich in die index.php-Datei als Kommentar hineingeschrieben.
Unten ist sie vorab nochmal.
Viel Spaß damit !
Ach ja: Die PHP-Datei darf jeder gerne verwenden, ändern und weitergeben wie er/sie möchte. Nur Geld nehmen soll dafür keiner!

*/

?>
